/*
PROGRAMMA DI SIMULAZIONE DI LETTURA/SCRITTURA SU MEMORIE RAM

Questo programma consente di simulare il funzionamento di una RAM scegliendone 
a piacere l'organizzazione (pin di dato e pin di indirizzo).

Sulla memoria  possibile effettuare operazioni di lettura e scrittura, inserendo
l'indirizzo e il dato (in binario) e agendo sugli ingressi
R/W (comanda lettura oppure scrittura) e OE (abilita o disabilita i pin di uscita).


AVVERTENZE:
Questo programma di simulazione RAM  composto in pratica da un menu
e da una visualizzazione, ma non effettua nessuna simulazione.

Le operazioni scelte non hanno nessun effetto, tranne quello
di modificare il valore di alcune variabili del programma.

Modificare il programma in modo opportuno in modo da rendere
il simulatore di RAM funzionante. Utilizzare un array di interi per simulare
la memoria.

Siccome l'array in C utilizza per l'indice e i valori i numeri decimali, conviene
usare due funzioni per la conversione da binario a decimale e da decimale
a binario (se non le si ha, si possono reperire facilmente in Internet).
*/


#include <cstdlib>
#include <iostream>
#include <math.h>
using namespace std;

int main(int argc, char *argv[])
{
    int ndato, naddr, scelta=-1, RW=1, OE=1, datoin=-1,addr=-1, datoout=-1;
    cout<<"BENVENUTI NEL SUPER PROGRAMMA DI SIMULAZIONE SRAM\n";
    cout<<"*************************************************\n\n";
    cout<<"Scegli il numeri di pin di dato della memoria:";
    cin>>ndato;
    cout<<"Scegli il numeri di pin di indirizzo della memoria:";
    cin>>naddr;

    while (scelta!=5)
    {
    cout<<"\n\t\tSRAM "<<(int) pow(2,naddr)<<" x "<<ndato<<"\t";

    cout<<"R/W = ";
    if (RW==1)
        cout<<"H\t\t";
    else
        cout<<"L\t\t";

    cout<<"OE = ";
    if (OE==1)
        cout<<"H\n";
    else
        cout<<"L\n";

    cout<<"\t\tData Out = ";
    if (OE==0)
        cout<<datoout<<"\t";
    else
        cout<<"HiZ\t";       

    cout<<"Data In = ";
    if (datoin!=-1)
        cout<<datoin<<"\t";
    else
        cout<<"nA\t";       

    cout<<"Address = ";
    if (addr!=-1)
        cout<<addr<<"\n";
    else
        cout<<"nA\n\n";       

        
    cout<<"1) Fornisci dato\n";
    cout<<"2) Fornisci indirizzo\n";
    cout<<"3) Toggle livello R/W\n";
    cout<<"4) Toggle livello OE\n";
    cout<<"5) Esci\n";
    cout<<"\nScegli: ";
    cin>>scelta;
    
    switch (scelta)
        {
        case 1:
            cout<<"\nDato Input (in binario): ";
            cin>>datoin;
            break;
            
        case 2:
            cout<<"\nIndirizzo (in binario): ";
            cin>>addr;
            break;
            
        case 3:
            if (RW==1)
                RW=0;
            else
                RW=1;
            cout<<"RW TOGGLED!\n";
            break;
            
        case 4:
            if (OE==1)
                OE=0;
            else
                OE=1;
            cout<<"OE TOGGLED!\n";
            break;
        }
    
    }
    
    system("PAUSE");
    return EXIT_SUCCESS;
}
